/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumDatatype;
import de.ship.db.tables.records.VRestVariableRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.JSONB;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VRestVariable extends TableImpl<VRestVariableRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_rest_variable</code>
     */
    public static final VRestVariable V_REST_VARIABLE = new VRestVariable();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VRestVariableRecord> getRecordType() {
        return VRestVariableRecord.class;
    }

    /**
     * The column <code>common_dd.v_rest_variable.unique_name</code>.
     */
    public final TableField<VRestVariableRecord, String> UNIQUE_NAME = createField(DSL.name("unique_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_rest_variable.valuelist</code>.
     */
    public final TableField<VRestVariableRecord, JSONB> VALUELIST = createField(DSL.name("valuelist"), SQLDataType.JSONB, this, "");

    /**
     * The column <code>common_dd.v_rest_variable.data_type</code>.
     */
    public final TableField<VRestVariableRecord, EnumDatatype> DATA_TYPE = createField(DSL.name("data_type"), SQLDataType.VARCHAR.asEnumDataType(EnumDatatype.class), this, "");

    /**
     * The column <code>common_dd.v_rest_variable.missinglist</code>.
     */
    public final TableField<VRestVariableRecord, JSONB> MISSINGLIST = createField(DSL.name("missinglist"), SQLDataType.JSONB, this, "");

    private VRestVariable(Name alias, Table<VRestVariableRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VRestVariable(Name alias, Table<VRestVariableRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_rest_variable" as  WITH vlist(fk_valuelist, valuelist) AS (
                WITH vl(fk_valuelist, valuekey, value) AS (
                        SELECT v_1.fk_value_valuelist,
                           v_1.varvalue,
                           jsonb_object_agg(l.isocode, l.value) AS jsonb_object_agg
                          FROM ((common_dd.t_core_value v_1
                            LEFT JOIN common_dd.t_core_valueparam p ON ((p.fk_valueparam_value = v_1.pk_core_value)))
                            LEFT JOIN common_dd.t_core_translation l ON ((l.fk_trans_key = p.param_key)))
                         WHERE (l.isocode IS NOT NULL)
                         GROUP BY v_1.fk_value_valuelist, v_1.varvalue, v_1.value_order
                         ORDER BY v_1.fk_value_valuelist, v_1.value_order
                       )
                SELECT vl_1.fk_valuelist,
                   jsonb_object_agg(vl_1.valuekey, vl_1.value) AS jsonb_object_agg
                  FROM vl vl_1
                 GROUP BY vl_1.fk_valuelist
               ), mis(missing_key, missinglist) AS (
                WITH ml(pk, num_missingcode, description) AS (
                        SELECT mv.fk_missinglist,
                           dmc.num_missingcode,
                           jsonb_build_object('class', mic.name, 'sas_missingcode', dmc.sas_missingcode, 'date_missingcode', dmc.date_missingcode, 'reproducible', mm.reproducible, 'missingvalue_ecrf', mv.missingvalue_ecrf, 'translation', jsonb_object_agg(l.isocode, l.value)) AS jsonb_build_object
                          FROM ((((((common_dd.t_core_missingvalue mv
                            LEFT JOIN common_dd.t_core_missingclass mic ON ((mic.pk = mv.fk_missingclass)))
                            LEFT JOIN common_dd.t_core_missingmaster mm ON ((mm.pk = mv.fk_missingmaster)))
                            LEFT JOIN common_dd.t_core_translation l ON ((l.fk_trans_key = mm.fk_lang)))
                            LEFT JOIN common_dd.t_core_missinglist ml_1 ON ((ml_1.pk = mv.fk_missinglist)))
                            LEFT JOIN common_dd.t_dm_missingvalue dmv ON ((dmv.fk_core_missingvalue = mv.pk)))
                            LEFT JOIN common_dd.t_dm_missingcode dmc ON ((dmc.pk = dmv.fk_missingcode)))
                         WHERE (dmc.num_missingcode IS NOT NULL)
                         GROUP BY mv.pk, mic.name, mv.fk_missinglist, dmc.num_missingcode, dmc.sas_missingcode, dmc.date_missingcode, mm.reproducible, ml_1.name, mv.missingvalue_ecrf
                         ORDER BY mv.fk_missinglist, dmc.num_missingcode
                       )
                SELECT ml.pk,
                   jsonb_object_agg(ml.num_missingcode, ml.description) AS missinglist
                  FROM ml
                 GROUP BY ml.pk
               )
        SELECT COALESCE(h.unique_name, h.dn) AS unique_name,
           vl.valuelist,
           v.data_type,
           m.missinglist
          FROM (((common_dd.t_core_variable v
            LEFT JOIN common_dd.t_core_element_hierarchy h ON ((h.key_element = v.key_variable)))
            LEFT JOIN vlist vl ON ((vl.fk_valuelist = v.fk_var_valuelist)))
            LEFT JOIN mis m ON ((m.missing_key = v.fk_missinglist)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_rest_variable</code> table reference
     */
    public VRestVariable(String alias) {
        this(DSL.name(alias), V_REST_VARIABLE);
    }

    /**
     * Create an aliased <code>common_dd.v_rest_variable</code> table reference
     */
    public VRestVariable(Name alias) {
        this(alias, V_REST_VARIABLE);
    }

    /**
     * Create a <code>common_dd.v_rest_variable</code> table reference
     */
    public VRestVariable() {
        this(DSL.name("v_rest_variable"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VRestVariable as(String alias) {
        return new VRestVariable(DSL.name(alias), this);
    }

    @Override
    public VRestVariable as(Name alias) {
        return new VRestVariable(alias, this);
    }

    @Override
    public VRestVariable as(Table<?> alias) {
        return new VRestVariable(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VRestVariable rename(String name) {
        return new VRestVariable(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VRestVariable rename(Name name) {
        return new VRestVariable(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VRestVariable rename(Table<?> name) {
        return new VRestVariable(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestVariable where(Condition condition) {
        return new VRestVariable(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestVariable where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestVariable where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestVariable where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRestVariable where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRestVariable where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRestVariable where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VRestVariable where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestVariable whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VRestVariable whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
